use axum::body::Bytes;
use axum::extract::Path;
use axum::http::HeaderMap;
use log::{debug, info};

use std::fs::File;
use std::io::Write;

use crate::sanitize_printable;

pub async fn inbox_post(Path(user): Path<String>, headers: HeaderMap, bytes: Bytes) {
    info!("Got post to inbox of user: {:?}", user);
    debug!("With headers: {:#?}", headers);
    File::create("./last.json")
        .map(|mut res| {
            res.write_all(&bytes).expect("Failed writing");
            println!("Writing file");
        })
        .expect("Failed to create file");

    let json = String::from_utf8(Vec::from(bytes)).expect("Invalid UTF-8");
    let json: serde_json::Value = serde_json::from_str(&json).expect("Invalid JSON");

    match serde_json::to_string_pretty(&json) {
        Ok(pretty_json) => info!("Received JSON:\n{}\n\n", sanitize_printable(&pretty_json)),
        Err(err) => info!("Failed to format JSON: {}\n\n", err),
    }
}
